<div class="noi-dung" ng-controller="angular-js-state">
    <div class="thanh-dieu-huong">
        <div>
            <h3>Angular JS</h3>
            <ul>
                <li><a href ng-click="angFState1()">1 - Giới thiệu về AngularJS</a></li>
                <li><a href ng-click="angFState2()">2 - Modules và các Controllers</a></li>
                <li><a href ng-click="angFState3()">3 - Đối tượng Scope và rootScope</a></li>
                <li><a href ng-click="angFState4()">4 - Directives và cách dùng</a></li>
                <li><a href ng-click="angFState5()">5 - Binding dữ liệu</a></li>
                <li><a href ng-click="angFState6()">6 - Routing, điều hướng</a></li>
                <li><a href ng-click="angFState7()">7 - Thiết lập sự kiện</a></li>
                <li><a href ng-click="angFState8()">8 - Ứng dụng vào thực tế</a></li>
                <li><a href ng-click="angFState9()">9 - Ưu, nhược điểm</a></li>
                <li><a href ng-click="angFState10()">10 - Lời kết</a></li>
            </ul>
        </div>
        <div ng-controller="node-js-state">
            <h3>Node JS</h3>
            <ul>
                <li><a href ng-click="nodFState1()">1 - Giới thiệu về NodeJS</a></li>
                <li><a href ng-click="nodFState2()">2 - Các Framework phổ biến</a></li>
                <li><a href ng-click="nodFState3()">3 - Thao tác trên cmd Win32</a></li>
                <li><a href ng-click="nodFState4()">4 - Các Module của nodeJS</a></li>
                <li><a href ng-click="nodFState5()">5 - Callback, Events trong nodeJS</a></li>
                <li><a href ng-click="nodFState6()">6 - Streams, Buffer trong nodeJS</a></li>
                <li><a href ng-click="nodFState7()">7 - HTTP Web Server trong nodeJS</a></li>
                <li><a href ng-click="nodFState8()">8 - Timers, Crawl trong nodeJS</a></li>
                <li><a href ng-click="nodFState9()">9 - Ưu, nhược điểm</a></li>
                <li><a href ng-click="nodFState10()">10 - Lời kết</a></li>
            </ul>
        </div>
        <!-- <div ng-controller="c-sharp-state">
            <h3>C#</h3>
            <ul>
                <li><a href ng-click="cshFState1()">1</a></li>
                <li><a href ng-click="cshFState2()">2</a></li>
                <li><a href ng-click="cshFState3()">3</a></li>
                <li><a href ng-click="cshFState4()">4</a></li>
                <li><a href ng-click="cshFState5()">5</a></li>
                <li><a href ng-click="cshFState6()">6</a></li>
                <li><a href ng-click="cshFState7()">7</a></li>
                <li><a href ng-click="cshFState8()">8</a></li>
                <li><a href ng-click="cshFState9()">9</a></li>
                <li><a href ng-click="cshFState10()">10</a></li>
            </ul>
        </div> -->
    </div>
    <div class="noi-dung-trinh-bay" ng-show="angState1">
        <h3>Giới thiệu về Angular JS</h3>
        <p class="van-ban">
            &emsp;
            Angular là một bộ Javascript Framework rất mạnh và thường được sử dụng để xây dựng project Single Page
            Application (SPA).
            <br>
            <img src="https://enterpriseleague.com/blog/wp-content/uploads/angular-startups.png" alt=""
                class="anh-noi-dung">
            &emsp;
            Nó hoạt động dựa trên các thuộc tính mở rộng HTML (các atributes theo quy tắc của Angular).
            <br>
            <img src="img/angular-attributes.png" alt="" class="anh-noi-dung">
            &emsp;
            Đây là một Framework mã nguồn mở hoàn toàn miễn phí và được hàng ngàn các lập trình viên trên thế giới ưa
            chuộng và sử dụng.
            <br>
            <img src="https://freetuts.net/upload/tut_post/images/2014/11/09/200/cac-thanh-phan-cua-angular-js.png"
                alt="" class="anh-noi-dung">
            &emsp;
            Framework này được thế hệ Web 2.0 phát triển khá mạnh ở nước ngoài, tuy nhiên ở Việt Nam thì vẫn chưa thông
            dụng lắm.
            <br>
            &emsp;
            Để sử dụng framework này, ta phải khai báo thư viện:
            <span class="code-center" style="font-size: 17pt; color: crimson;">
                {{angularScript}}
            </span>
        </p>
    </div>
    <div class="noi-dung-trinh-bay" ng-hide="angState2">
        <h3>Module và các Controllers</h3>
        <p class="van-ban">
            <img src="img/angular-modules.png" alt="Angular Modules Presentation Picture No.1" class="anh-noi-dung">
            <br>
            &emsp;
            Một Modules (mô-đun) AngularJS xác định một ứng dụng (Application). Mô-đun là một nơi chứa cho các phần khác
            nhau (controller, config, scope,...) của một ứng dụng. Mô-đun là một container cho các bộ điều khiển
            (Controller) ứng dụng. Bộ điều khiển luôn thuộc về một mô-đun.
            <br>
            &emsp;
            Cách tạo ra một modules trong angularJS:
            <br>
            <img src="img/angular-modules-2.png" alt="" class="anh-noi-dung">
            <br>
            Chúng ta sử dụng tính năng của AngularJS:
            <br>
            <span class="code-center">angular.module('myApp', []);</span>
            <br>
            "myApp" sẽ được liên lạc bên thẻ/đối tượng (thường Flà body/div hoặc html) trong file HTML.
            <br>
            <img src="img/angular-controller.png" alt="" class="anh-noi-dung">
            <br>
            &emsp;
            Trong Angular, Controller là một hàm khởi tạo có nhiệm vụ thực hiện xử lý dữ liệu cho đối tượng $scope, từ
            đây bên Views sẽ sử dụng các dữ liệu trong $scope để hiển thị ra tương ứng.
            <br>
            <img src="img/angular-controller-2.png" alt="" class="anh-noi-dung">
            <br>
            Bên views:
            <br>
            <img src="img/angular-controller-3.png" alt="" class="anh-noi-dung">
            <br>
            &emsp;
            Khi một controller được gán vào các DOM trong HTML bằng thuộc tính chỉ thị ng-controller thì Angular sẽ nhận
            biết và tạo một đối tượng Controller mới sử dụng như là một hàm khởi tạo, nghĩa là sẽ được chạy khi website
            được load xong. Lúc này Angular cũng tạo luôn một đối tượng $scope mới dành riêng cho controller đó. Công
            thức:
            <span class="code-center">
                app.controller('name', function() {});
            </span>
        </p>
    </div>
    <div class="noi-dung-trinh-bay" ng-hide="angState3">
        <h3>Đối tượng Scope và rootScope</h3>
        <p class="van-ban">
            <img src="img/angular-scope-1.png" alt="" class="anh-noi-dung">
            <br>
            &emsp;
            $scope là một object (đối tượng) có nhiệm vụ giao tiếp dữ liệu giữa controller và view của ứng dụng. Nó sẽ
            thực hiện dưới dạng biểu thức, nghĩa là ở model sẽ được khai báo đúng với quy cách thì đối tượng scope sẽ
            truyền hành động (function) hoặc dữ liệu tương ứng và ta có thể truyền các sự kiện thông qua đối tượng này.
            <br>
            <img src="img/angular-scope-2.png" alt="" class="anh-noi-dung">
            &emsp;
            Scopes cung cấp các biểu thức giống như các template engine hiện nay, ví dụ để hiển thị username thì ta sẽ
            khai báo là {{username}} và ở controller chúng ta chỉ việc gán
            <br>
            <span class="code-center">$scope.username = 'something'</span>
            <br>
            thì đối tượng
            này sẽ lấy key có tên là username gán vào view {{username}}.
            <img src="img/angular-scope-3.png" alt="" class="anh-noi-dung">
            <br>
            <img src="img/angular-scope-4.png" alt="" class="anh-noi-dung">
            <br>
            &emsp;
            Tất cả các application đều có $rootScope được tạo sẵn trong đối tượng HTML có được ng-app điều hướng sẵn.
            <br>
            <img src="img/angular-scope-5.png" alt="" class="anh-noi-dung">
            &emsp;
            Điều này có nghĩa là khi ứng dụng được chạy thì sẽ có một $rootScope được tự động tạo, $rootScope là bậc cao
            nhất nên sẽ bao quát hết các $scope bên trong nó, điêu này không giống với $scope là chỉ ảnh hưởng trong
            phạm vi của controller.
        </p>
    </div>
    <div class="noi-dung-trinh-bay" ng-hide="angState4">
        <h3>Directives và cách dùng</h3>
        <p class="van-ban">
            <img src="img/angular-directives-1.png" alt="" class="anh-noi-dung">
            &emsp;
            Directives là một thành phần mở rộng HTML, hay nói cách khác là các thuộc tính (properties) của các thẻ HTML
            mà Angular nó định nghĩa thêm, vì nó của riêng của Angular nên phải tuân thủ theo nguyên tắc của nó là chữ
            bắt đầu luôn luôn là ký tự "ng-prefix", trong đó tiền tố prefix là tên của derective mà chúng ta
            sử dụng.
            <br>
            &emsp;
            Để khai báo là một Directive Controller thì khai báo:
            <span class="code-center">
                ng-controller
            </span>
            <br>
            <br>
        </p>
        <h4>Danh sách AngularJS Directives phổ biến</h4>
        <ul>
            <li>ng-app</li>
            <li>ng-init</li>
            <li>ng-model</li>
            <li>ng-bind</li>
            <li>ng-show, ng-hide</li>
            <li>. . .</li>
        </ul>
        <p class="van-ban">
            &emsp;
            Ngoài các Directives kể trên, ta có thể tự định nghĩa một directive riêng mang tính cá nhân, cú pháp:
            <span class="code-center">
                app.directive("tenDir", function() {});
            </span>
            <br>
            <img src="img/angular-directives-2.png" alt="" class="anh-noi-dung">
        </p>
    </div>
    <div class="noi-dung-trinh-bay" ng-hide="angState5">
        <h3>Binding dữ liệu</h3>
        <p class="van-ban">
            <img src="img/angular-binding-1.png" alt="" class="anh-noi-dung">
            &emsp;
            Binding dữ liệu trong AngularJS là sự đồng bộ hóa dữ liệu giữa model và view. Phần này là thế mạnh của
            AngularJS vì tính năng mạnh mẽ mà tốn ít tài nguyên hệ thống, thuận tiện cho phát triển front-end.
            <br>
            &emsp; Sử dụng thuộc tính bind:<span class="code-center">ng-bind</span>
            <img src="img/angular-binding-2.png" alt="" class="anh-noi-dung">
            &emsp;
            Sử dụng thuộc tính model với input/select/...:
            <br><span class="code-center">
                ng-model='tenModel'
            </span>
            <img src="img/angular-binding-3.png" alt="" class="anh-noi-dung">
            hoặc
            <br>
            <span class="code-center">
                cặp ngoặc nhọn '{{tenModel}}'
            </span>
            <br>
            <img src="img/angular-binding-4.png" alt="" class="anh-noi-dung">
            <img src="img/angular-binding-5.png" alt="" class="anh-noi-dung">
        </p>
    </div>
    <div class="noi-dung-trinh-bay" ng-hide="angState6">
        <h3>Routing, điều hướng</h3>
        <p class="van-ban">
            <img src="img/angular-routing-1.png" alt="" class="anh-noi-dung">
            <span class="code-center" style="color: crimson;">
                ngRoute
            </span>
            &emsp;
            Mô-đun này sẽ giúp ứng dụng trở thành <a href="https://phambinh.net/bai-viet/single-page-application-la-gi-co-phai-la-xu-huong-lap-trinh-web-trong-tuong-lai/" style="text-decoration: none; color:blue;">Single Page Application</a> (SPA) (1 Trang thống nhất).
            <br>
            &emsp;
            Việc điều hướng giữa các trang sẽ mượt mà hơn, trang không cần tải lại. Đây là sức mạnh của 'ngRoute'.
            <img src="img/angular-routing-2.png" alt="" class="anh-noi-dung">
            <br>
            &emsp;
            Để sử dụng, ta cần có:
            <span class="code-center" style="font-size: 17pt; color: crimson;">
                {{ngRouteScript}}
            </span>
            <span class="code-center" style="font-size: 17pt; color: crimson;">
                var app = angular.module('myApp', ['ngRoute']);
            </span>
            và định nghĩa
            <span class="code-center" style="font-size: 17pt; color: crimson;">
                $routeProvider.when('/ten-duong-dan', { templateUrl: 'dich-den.htm'});
            </span>
            &emsp;Ví dụ thực tế:
            <img src="img/angular-routing-1.png" alt="" class="anh-noi-dung">

        </p>
    </div>
    <div class="noi-dung-trinh-bay" ng-hide="angState7">
        <h3>Thiết lập sự kiện</h3>
        <p class="van-ban">
            &emsp;
            AngularJS cũng được trang bị rất nhiều directives sự kiện trên HTML.
        </p>
        <ul class="list-dai">
            <li>ng-blur</li>
            <li>ng-change</li>
            <li>ng-click</li>
            <li>ng-copy</li>
            <li>ng-cut</li>
            <li>ng-dbclick</li>
            <li>ng-focus</li>
            <li>ng-keydown</li>
            <li>ng-keypress</li>
            <li>ng-keyup</li>
            <li>ng-mousedown</li>
            <li>ng-mouseenter</li>
            <li>ng-mouseleave</li>
            <li>ng-mousemove</li>
            <li>ng-mouseover</li>
            <li>ng-mouseup</li>
            <li>ng-paste</li>
        </ul>
        <p class="van-ban">
            <br>
            Để hiểu rõ hơn, truy cập <a href="https://www.w3schools.com/angular/angular_events.asp" style="text-decoration: none;">tại đây</a>!
        </p>
    </div>
    <div class="noi-dung-trinh-bay" ng-hide="angState8">
        <h3>Ứng dụng vào thực tế</h3>
        <p class="van-ban">
            &emsp;
            Bản báo cáo này được viết trên thư viện script AngularJS phiên bản 1.6.9.
            <br>
        </p>
    </div>
    <div class="noi-dung-trinh-bay" ng-hide="angState9">
        <h3>Ưu, nhược điểm</h3>
        <table class="bang-van-ban">
            <thead>
                <tr>
                    <th style="color: rgb(0, 255, 102); font-weight: 700;">Ưu điểm</th>
                    <th style="color: rgb(255, 0, 0); font-weight: 700;">Nhược điểm</th>
                </tr>
            </thead>
            <tbody>
                <tr>
                    <td>AngularJS cho phép tạo ra các ứng dụng một cách đơn giản, code sạch.</td>
                    <td rowspan="2">Không an toàn: Được phát triển từ javascript nên nó không an toàn, phía máy chủ phải thường xuyên xác nhận quyền để hệ thống chạy trơn tru.</td>
                </tr>
                <tr>
                    <td>AngularJS sử dụng data bind giống .NET với tính năng liên kết với HTML nên giúp người dùng cảm thấy dễ chịu.</td>
                    <td></td>
                </tr>
                <tr>
                    <td>Angular có thể chạy trên hầu hết các trình duyệt điện thoại thông minh.</td>
                    <td>Phụ thuộc: Nếu người dùng vô hiệu hóa javascript thì toàn bộ mô-đun điều hướng ngưng hoạt động.</td>
                </tr>
                <tr>
                    <td>AngularJS tuy kết thúc hỗ trợ chính thức tháng 2 năm 2022, nhưng cộng đồng hỗ trợ rất mạnh và đông.</td>
                    <td>Đã ngừng cập nhật tháng 02 năm 2022, thay thế bằng các bản Angular (phiên bản kế nhiệm của AngularJS) mới hơn.</td>
                </tr>
            </tbody>
        </table>
    </div>
    <div class="noi-dung-trinh-bay" ng-hide="angState10">
        <h3>Lời kết</h3>
        <p class="van-ban">
            &emsp;
            AngularJS là một framework dễ học, dễ tìm hiểu, cộng đồng hỗ trợ lớn và là một lựa chọn tuyệt vời để khởi đầu con đường lập trình Web chuyên nghiệp.
        </p>
    </div>
</div>